=== debian/changelog ===
stress-ng (0.15.06-2) unstable; urgency=medium

  * Fix random buffer filling issue
    - 0001-core-helper-fix-stress_rndbuf-to-fill-entire-buff.patch
  * Re-enable af-alg stressor if ipsec-mb is not available
    - 0002-stress-af-alg-remove-check-for-HAVE_LIB_IPSEC_MB.patch

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 20 Mar 2023 09:43:11 +0000

stress-ng (0.15.06-1) unstable; urgency=medium

  * Makefile: bump version
  * README.md: add another citation
  * Manual: update date
  * debian/testing/fast-test-all: remove --klog-check
  * stress-ng: fix truncated pr_inf call
  * stress-ng: add --oom-avoid-bytes option for the free memory avoid
    allocation threshold
  * stress-cache: remove % operator, using compare and re-assign to zero
  * stess-msg: add --msg-bytes option to specify size of message being
    sent/recv'd
  * stress-msg: voidify return of msgctl
  * stress-*, test-*: remove trailing spaces at end of lines
  * stress-shm-sysv: define SHM_HUGE_* macros if required, drop IPC_PRIVATE
    error check
  * stress-shm-sysv: add SHM_HUGE_2MB flag when using SHM_HUGETLB
  * stess-shm-sysv: plumb in --sym-sysv-bytes option to correct ID
  * stress-shm-sysv: replace IPC_RMID with IPC_PRIVATE in error message
  * stress-shm-sysv: add missing space in error message
  * stress-cyclic: report the number of samples required for the test run
  * stress-memrate: make vector types based on uint32_t, add prefetch 128
  * stress-memrate: make prefetch offset 2K
  * stress-memrate: remove inner loops for non-memory rate timed functions
  * stress-memrate: remove keep_stressing check, use siglongjmp in alarm
    handler
  * stress-memrate: add in further loop optimizations
  * stress-vm: explicitly add modulo inline helper function
  * core-helper: add stress_get_prime64 to get prime above a given value
  * core-helper: rename stress_get_prime64 to stress_get_next_prime64
  * stress-memrate: fix --memrate-wr-mbs/rd-mbs, use best fit size, add
    memset writes too
  * stress-vm: skip stressor when out of resources, return EXIT_NO_RESOURCES
  * stress-vm: fix prime index accumulation overflow and speed up modulo
  * stress-vm: compute a new prime that is larger than sz rather than use
    PRIME_64

 -- Colin Ian King <colin.i.king@gmail.com>  Thu, 16 Mar 2023 12:47:17 +0000

stress-ng (0.15.05-1) unstable; urgency=medium

  [Erik Stahlman]
  * Populate jmp_env before it could be used

  [Julien Olivain]
  * Makefile: introduce PRESERVE_CFLAGS build flag
  * stress-regs: fix build on riscv32
  * stress-mmap: fix build with HAVE_SYSCALL or __NR_mmap2 is undefined

  [Colin Ian King]
  * Makefile: bump version
  * Manual: simplify the contributors text and put a link to the README.md
    file
  * README.md: add contributors
  * README.md: update notes about icc, icx and musl-gcc
  * stress-ng.h: disable fast math for icc, it's not supported yet
  * core-pragma: generalize unroll n to unroll for Intel icc compiler
  * Manual: add bold notes about using bogo-ops as a benchmarking metric
  * stress-pthread: call sys_set_robust_list using copy of head on
    the stack
  * stress-pthread: disable set_robust_list calls
  * stress-mremap: pass an illegal remapping address rather than null
  * core-pragma: bump clang version for STRESS_PRAGMA_WARN_CPP_OFF
  * core-pragma: define STRESS_PRAGMA_WARN_CPP_OFF for different compiler
   versions
  * stress-qsort: cast return of mmap to same type as data
  * stress-ng: only define OPTIMIZE_FAST_MAST with fast math attribute
    for gcc 10+
  * stress-brk: voidify two more args to clean up OS X build warning
  * stress-brk: clean up OS X build warning
  * stress-lockbus: enable for tested targets
  * stress-lockbus: enable riscv
  * stress-lock: try alternative __atomic_fetch_add if add_fetch is not
    available
  * stress-cpu: collatz: force compiler to generate collatz computation
  * stress-cpu: explog: add randomness, stash intermediates to force exp
    and log calls
  * stress-cpu: add some randomness to force code generation of
    computation
  * Makefile: fix typo, remove i after parisc
  * stress-tee: use correct format specifiers for size_t values
  * stress-chown: fix incorrect goto before zero ret check
  * Avoid division by zero
  * stress-cache: fix incorrect variable being passed to cache helper
    functions
  * stress-zero: exercise a couple of ioctls
  * stress-full: exercise a couple of ioctls
  * stress-shellsort: remove 8 bit sort, replace it with 32 bit mangling
  * stress-mergesort: remove 64 bit sort, replace it with 32 bit mangling
  * stress-heapsort: remove 8 bit sort, replace it with 32 bit mangling
  * core-sort: move stress_sort_data_int32_mangle from stress-qsort to
    core-sort
  * stress-rtc: add const to * ptr
  * stress-rmap: add yield check, helps BSD systems when touching many
    pages
  * stress-evivar: use a lookup table for names to ignore
  * stress-l1cache: add a l1cache method to select forward, random or
    reverse cache exercising
  * stress-wcs: remove redundant forward declaration of wcs
  * stress-str: remove redundant forward declaration of metrics
  * stress-x86cpuid: reduce scope of variables eax, ebx, ecx and edx
  * test/test-timerfd-create: remove unused variable fd
  * stress-vm-rw: memset stack to zero to silence pedantic static
    analyzers
  * stress-vdso: reduce scope of variable str
  * stress-ng: reduce scope of variable ret
  * stress-shm-sysv: rename sz to shmmax and add it to error message
  * stress-sigio: reduce scope of buffer
  * stress-rawdev: reduce scope of rate, constify rate and duration
  * stress-prctl: change scope of declaration of ret
  * stress-prctl: voidify ret
  * stress-mutex: only declare cpus if (HAVE_PTHREAD_SETAFFINITY_NP is
    defined
  * stress-ipsec-mb: move declaration of ptr into context that uses it
  * stress-cyclic: rename noclobber rc to ncrc
  * core-vmstat: move variables into more local context

