## stress-ng 0.16.02

=== Makefile ===
--- 
+++ 
@@ -17,10 +17,13 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.15.06
-#
-# Codename "hegemonic huffy haddock"
-#
+VERSION=0.16.02
+#
+# Codename "capable cache cruncher"
+#
+
+KERNEL=$(shell uname -s)
+NODENAME=$(shell uname -n)
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
 #
@@ -56,7 +59,7 @@
 endif
 ifneq ($(findstring pcc,$(CC)),pcc)
 ifeq ($(shell $(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -D_FORTIFY_SOURCE=2
+CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
 endif
 endif
 endif
@@ -93,6 +96,12 @@
 endif
 endif
 
+ifeq ($(findstring gcc,$(CC)),gcc)
+ifneq ($(KERNEL),SunOS)
+CFLAGS += -ftree-loop-vectorize
+endif
+endif
+
 #ifeq ($(findstring clang,$(CC)),clang)
 #CFLAGS += -Weverything
 #endif
@@ -101,8 +110,6 @@
 #
 # SunOS requires special grep for -e support
 #
-KERNEL=$(shell uname -s)
-NODENAME=$(shell uname -n)
 ifeq ($(KERNEL),SunOS)
 ifneq ($(NODENAME),dilos)
 GREP = /usr/xpg4/bin/grep
@@ -160,6 +167,7 @@
 	core-vecmath.h \
 	core-version.h \
 	stress-af-alg-defconfigs.h \
+	stress-eigen-ops.h \
 	stress-ng.h
 
 #
@@ -220,6 +228,7 @@
 	stress-dnotify.c \
 	stress-dup.c \
 	stress-dynlib.c \
+	stress-eigen.c \
 	stress-efivar.c \
 	stress-enosys.c \
 	stress-env.c \
@@ -238,6 +247,7 @@
 	stress-filename.c \
 	stress-flock.c \
 	stress-flushcache.c \
+	stress-fma.c \
 	stress-fork.c \
 	stress-forkheavy.c \
 	stress-fp.c \
@@ -316,7 +326,9 @@
 	stress-mmapfork.c \
 	stress-mmaphuge.c \
 	stress-mmapmany.c \
+	stress-module.c \
 	stress-mprotect.c \
+	stress-mpfr.c \
 	stress-mq.c \
 	stress-mremap.c \
 	stress-msg.c \
@@ -488,6 +500,7 @@
 	core-helper.c \
 	core-icache.c \
 	core-ignite-cpu.c \
+	core-interrupts.c \
 	core-io-uring.c \
 	core-io-priority.c \
 	core-job.c \
@@ -508,6 +521,7 @@
 	core-out-of-memory.c \
 	core-parse-opts.c \
 	core-perf.c \
+	core-processes.c \
 	core-resources.c \
 	core-sched.c \
 	core-setting.c \
@@ -525,13 +539,14 @@
 
 SRC = $(CORE_SRC) $(STRESS_SRC)
 OBJS = apparmor-data.o
+OBJS += stress-eigen-ops.o
 OBJS += $(SRC:.c=.o)
 
 APPARMOR_PARSER=/sbin/apparmor_parser
 
 all: config.h stress-ng
 
-.SUFFIXES: .c .o
+.SUFFIXES: .cpp .c .o
 
 .o: Makefile
 
@@ -539,10 +554,23 @@
 	$(PRE_Q)echo "CC $<"
 	$(PRE_V)$(CC) $(CFLAGS) -c -o $@ $<
 
+#
+#  Use CC for linking if eigen is not being used, otherwise use CXX
+#
 stress-ng: config.h $(OBJS)
 	$(PRE_Q)echo "LD $@"
+	$(eval LINK_TOOL := $(shell if [ -n "$(shell grep '^#define HAVE_EIGEN' config.h)" ]; then echo $(CXX); else echo $(CC); fi))
 	$(eval LDFLAGS_EXTRA := $(shell cat config | grep CONFIG_LDFLAGS | sed 's/CONFIG_LDFLAGS += //' | tr '\n' ' '))
-	$(PRE_V)$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@
+	$(PRE_V)$(LINK_TOOL) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@
+
+stress-eigen-ops.o: config.h
+	@if grep -q '^#define HAVE_EIGEN' config.h; then \
+		echo "CXX stress-eigen-ops.cpp";	\
+		$(CXX) -c -o stress-eigen-ops.o stress-eigen-ops.cpp; \
+	else \
+		echo "CC stress-eigen-ops.c";	\
+		$(CC) -c -o stress-eigen-ops.o stress-eigen-ops.c; \
+	fi
 
 config.h config:
 	$(PRE_Q)echo "Generating config.."
@@ -552,21 +580,3 @@
 
 #
 #  generate apparmor data using minimal core utils tools from apparmor
-#  parser output
-#
-apparmor-data.o: usr.bin.pulseaudio.eg config.h
-	$(PRE_Q)rm -f apparmor-data.bin
-	$(PRE_V)if [ -n "$(shell grep '^#define HAVE_APPARMOR' config.h)" ]; then \
-		echo "Generating AppArmor profile from usr.bin.pulseaudio.eg"; \
-		$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin >/dev/null 2>&1 ; \
-	else \
-		echo "Generating empty AppArmor profile"; \
-		touch apparmor-data.bin; \
-	fi
-	$(PRE_V)echo "#include <stddef.h>" > apparmor-data.c
-	$(PRE_V)echo "char g_apparmor_data[]= { " >> apparmor-data.c
-	$(PRE_V)od -tx1 -An -v < apparmor-data.bin | \
-		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
-		sed '$$ s/.$$//' >> apparmor-data.c
-	$(PRE_V)echo "};" >> apparmor-data.c
-	$(PRE_V)rm -f apparmor-data.bin
