=== debian/changelog ===
stress-ng (0.16.02-1) unstable; urgency=medium

  * Makefile: bump version again
  * stress-cyclic: Fix segv caused by uninitialized variable cyclic_method
  * README.md: add repology information

 -- Colin Ian King <colin.i.king@gmail.com>  Thu, 13 Jul 2023 08:44:47 +0100

stress-ng (0.16.01-1) unstable; urgency=medium

  [ Pino Toscano ]
  * debian/control: Update/improve the build dependencies (Closes: #1040582)
    - enable libkeyutils-dev also on ia64, as it is available there as well
    - enable libjudy-dev, libxxhash-dev, and libglvnd-dev on all the
      architectures, as they are not specific to a certain OS
    - switch the build dependencies that exist only on Linux from
      "!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64" to "linux-any":
      libkeyutils-dev, libapparmor-dev, apparmor, libaio-dev, libcap-dev,
      libsctp-dev, libatomic1, libkmod-dev, libgbm-dev

  [ Colin Ian King ]
  * Makefile: bump version
  * Manual: update date
  * stress-shm-sysv: abort early if we run out of shm resources
  * stress-hash: fix index overrun during initialization
  * stress-hash: fix index overrun in stress_hash_all
  * stress-nop: add NOCLOBBER to pointer instr, clear Solaris gcc 4.8.2
    warning
  * stress-ng: fix sigprocmask, signals that need to be blocked are set,
    not zero'd
  * stress-bad-ioctl: replace next label with continue statement
  * core-setting: remove TYPE_ID_UINTPTR_T type
  * stress-zlib: replace null check in methods array with length check
  * stress-vm: replace null check in methods array with length check
  * stress-vm-addr: replace null check in methods array with length check
  * stress-switch: replace null check in methods array with length check
  * stress-sparsematrix: replace null check in methods array with length
    check
  * stress-opcode: replace null check in methods array with array length
    check
  * stress-misaligned: replace null check in methods array with length
    check
  * stress-cyclic: pass address of pointer rather than method address
  * stress-memcpy: replace null check in methods array with length check
  * stress-hash: replace null check in methods array with length check
  * stress-exec: replace null check in methods array with length check
  * stress-cyclic: replace null check in cyclic_methods with length check
  * stress-cpu: replace null check in cpu_methods with length check
  * Manual: fix typo in --cpu-offline-all option
  * Manual: some minor grammar changes
  * stress-ng: add --status N option to report stressor runs status every
    N seconds
  * stress-malloc: remove need for some global variables, clean up code
  * stress-schedpolicy: add --schedpolicy-rand option to select policy
    randomly
  * stress-bad-ioctl: fix fd leak
  * stress-chroot: add two standard methods of breaking out of a chroot
    as tests
  * stress-bad-ioctl: add --bad-ioctl-method to select how ioctl commands
    are changed
  * stress-stream: ensure number of elements is a multiple of unroll size
  * stress-ng: make child termination SIGALRM messages debug only
  * stress-ng: speed up child termination by blocking signals and skip
    excessive free'ing

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 11 Jul 2023 11:24:12 +0100

stress-ng (0.16.00-1) unstable; urgency=medium

  * Makefile: bump version to 0.16.00
  * core-helper: double size of temporary string buffer tmp
  * stress-ipsec-mb: use reverse compat macros for versions 0.55.00
  * stress-ipsec-mb: add reverse compat macros for version 0.52.0 or
    earlier
  * Manual: fix eigen table
  * stress-mlock: clean up pedantic warning on uninitialized pointer
    mappings
  * stress-cache: clean up longjmp clobber warnings on openhipster 202104
  * stress-mmap: check for NetBSD EPERM errors on page protection checks
  * stress-far-branch: disabled for NetBSD
  * stress-iomix: shrink file size if we hit EFBIG or ENOSPC
  * stress-copyfile: handle ENOSYS by skipping stressor
  * stress-misaligned: handle timeout by jmping back and restarting
  * kernel-coverage.sh: add more mlock options
  * README.md: fix ClearLinux libattr bundle name
  * stress-pagemove: add new --pagemove-mlock option
  * stress-memfd: add new --mefd-mlock option
  * stress-malloc: add new --malloc-mlock option
  * stress-llc-affinity: add new --llc-affinity-mlock option
  * kernel-coverage: add some more stressor options for more coverage
  * stress-physpage: voidify physpage_mtrr when not used
  * stress-bad-altstack: return EXIT_FAILURE insted of
    _exit(EXIT_FAILURE)
  * core-parse-opts: return 0 on err, clean up pedantic tcc warnings
  * stress-ng.h: undef _FORTIFY_SOURCE for TCC builds
  * core-killpid: break out of infinite loop and return via return path
  * stress-af-alg: add hmac(md5) to defconfigs
  * core-helper: add detection for Darwin libc
  * core-vmstat: clean up pedantic warning on const name array on OS X
  * stress-madvise: voidify hwpoison
  * stress-x86syscall: rename variables to avoid name shadowing
  * stress-open: remove shadowing variable ret
  * Manual: re-order options into alphabetical order, fix some hyphens
  * Manual: remove expand from tables now that x is being used
  * Manual: put code examples in courier font
  * Manual: use lx expand description in tables
  * Manual: add notes about the legacy io stressor
  * README.md: add another citation
  * Manual: remove x86 specific notes for icache stressor
  * stress-mmapaddr: remove trailing space
  * Manual: rephrase mlock options
  * stress-vm-addr: add new --vm-addr-mlock option
  * stress-waitcpu: only perform nop rate comparisons of x86
  * stress-stream: add new --stream-mlock option
  * stress-shm-sysv: add new --shm-sysv-mlock option
  * stress-shm: add new --shm-mlock option
  * stress-remap: add new --remap-mlock option
  * stress-resources: add new --resources-mlock option
  * stress-mmapmany: add new --mmapmany-mlock option
  * stress-mmaphuge: add new --mmaphuge-mlock option

