## stress-ng 0.17.05

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2013-2021 Canonical, Ltd.
-# Copyright (C) 2021-2023 Colin Ian King
+# Copyright (C) 2021-2024 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -17,31 +17,58 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.16.02
-#
-# Codename "capable cache cruncher"
+VERSION=0.17.05
+#
+# Codename "scintillating scheduler smasher"
 #
 
 KERNEL=$(shell uname -s)
 NODENAME=$(shell uname -n)
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
+override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99
+
+#
+#  Building stress-vnni with less than -O2 causes breakage with
+#  gcc-13.2, so remove then and ensure at least -O2 is used or
+#  honour flags > -O2 if they are provided
+#
+VNNI_OFLAGS_REMOVE=-O0 -O1 -Og
+VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))
+
 #
 # Default -O2 if optimization level not defined
 #
 ifeq "$(findstring -O,$(CFLAGS))" ""
-	CFLAGS += -O2
-endif
+	override CFLAGS += -O2
+endif
+ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
+	override VNNI_CFLAGS += -O2
+endif
+
+#
+# Debug flag
+#
+ifeq ($(DEBUG),1)
+override CFLAGS += -g
+endif
+
+#
+# Check if compiler supports flag set in $(flag)
+#
+cc_supports_flag = $(shell $(CC) -Werror $(flag) -E -xc /dev/null > /dev/null 2>&1 && echo $(flag))
 
 #
 # Pedantic flags
 #
 ifeq ($(PEDANTIC),1)
-CFLAGS += -Wcast-qual -Wfloat-equal -Wmissing-declarations \
+
+PEDANTIC_FLAGS := \
+	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
 	-Wmissing-format-attribute -Wno-long-long -Wpacked \
 	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
 	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
 	-DHAVE_PEDANTIC
+override CFLAGS += $(foreach flag,$(PEDANTIC_FLAGS),$(cc_supports_flag))
 endif
 
 #
@@ -50,25 +77,31 @@
 MACHINE = $(shell uname -m)
 ifneq ($(PRESERVE_CFLAGS),1)
 ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
-ifeq ($(shell $(CC) $(CFLAGS) -fstack-protector-strong -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -fstack-protector-strong
-endif
-endif
-ifeq ($(shell $(CC) $(CFLAGS) -Werror=format-security -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -Werror=format-security
-endif
-ifneq ($(findstring pcc,$(CC)),pcc)
-ifeq ($(shell $(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -E -xc /dev/null > /dev/null 2>& 1 && echo 1),1)
-CFLAGS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2
-endif
-endif
+flag = -Wformat -fstack-protector-strong \
+	-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 \
+	-Werror=format-security
+override CFLAGS += $(cc_supports_flag)
+endif
+endif
+
+#
+# Optimization flags
+#
+ifeq ($(findstring icc,$(CC)),)
+override CFLAGS += $(foreach flag,-fipa-pta,$(cc_supports_flag))
+endif
+#
+# Enable Link Time Optimization
+#
+ifeq ($(LTO),1)
+override CFLAGS += $(foreach flag,-flto=auto,$(cc_supports_flag))
 endif
 
 #
 # Expected build warnings
 #
 ifeq ($(UNEXPECTED),1)
-CFLAGS += -DCHECK_UNEXPECTED
+override CFLAGS += -DCHECK_UNEXPECTED
 endif
 
 #
@@ -90,20 +123,14 @@
 
 ifneq ($(PRESERVE_CFLAGS),1)
 ifeq ($(findstring icc,$(CC)),icc)
-CFLAGS += -no-inline-max-size -no-inline-max-total-size
-CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
-CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
-endif
-endif
-
-ifeq ($(findstring gcc,$(CC)),gcc)
-ifneq ($(KERNEL),SunOS)
-CFLAGS += -ftree-loop-vectorize
+override CFLAGS += -no-inline-max-size -no-inline-max-total-size
+override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
+override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
 endif
 endif
 
 #ifeq ($(findstring clang,$(CC)),clang)
-#CFLAGS += -Weverything
+#override CFLAGS += -Weverything
 #endif
 
 GREP = grep
@@ -120,8 +147,8 @@
 # Static flags, only to be used when using GCC
 #
 ifeq ($(STATIC),1)
-LDFLAGS += -static -z muldefs
-CFLAGS += -DBUILD_STATIC
+override LDFLAGS += -static -z muldefs
+override CFLAGS += -DBUILD_STATIC
 endif
 
 BINDIR=/usr/bin
@@ -129,34 +156,67 @@
 JOBDIR=/usr/share/stress-ng/example-jobs
 BASHDIR=/usr/share/bash-completion/completions
 
+
 #
 # Header files
 #
 HEADERS = \
 	core-arch.h \
+	core-affinity.h \
 	core-asm-arm.h \
+	core-asm-generic.h \
+	core-asm-loong64.h \
 	core-asm-ppc64.h \
 	core-asm-riscv.h \
 	core-asm-s390.h \
 	core-asm-sparc.h \
 	core-asm-x86.h \
+	core-asm-ret.h \
+	core-attribute.h \
 	core-bitops.h \
 	core-builtin.h \
 	core-capabilities.h \
+	core-clocksource.h \
+	core-config-check.h \
 	core-cpu.h \
 	core-cpu-cache.h \
+	core-cpuidle.h \
 	core-ftrace.h \
 	core-hash.h \
-	core-icache.h \
+	core-ignite-cpu.h \
+	core-interrupts.h \
 	core-io-priority.h \
+	core-job.h \
+	core-helper.h \
+	core-killpid.h \
+	core-klog.h \
+	core-limit.h \
+	core-lock.h \
+	core-log.h \
+	core-madvise.h \
+	core-mlock.h \
+	core-mmap.h \
+	core-mincore.h \
+	core-module.h \
+	core-mounts.h \
+	core-mwc.h \
 	core-nt-load.h \
 	core-nt-store.h \
 	core-net.h \
+	core-numa.h \
+	core-opts.h \
+	core-out-of-memory.h \
+	core-parse-opts.h \
 	core-perf.h \
 	core-pragma.h \
+	core-processes.h \
 	core-pthread.h \
 	core-put.h \
 	core-resources.h \
+	core-sched.h \
+	core-setting.h \
+	core-shared-heap.h \
+	core-shim.h \
 	core-smart.h \
 	core-sort.h \
 	core-stressors.h \
@@ -164,8 +224,11 @@
 	core-target-clones.h \
 	core-thermal-zone.h \
 	core-thrash.h \
+	core-time.h \
+	core-try-open.h \
 	core-vecmath.h \
 	core-version.h \
+	core-vmstat.h \
 	stress-af-alg-defconfigs.h \
 	stress-eigen-ops.h \
 	stress-ng.h
@@ -184,6 +247,7 @@
 #
 STRESS_SRC = \
 	stress-access.c \
+	stress-acl.c \
 	stress-affinity.c \
 	stress-af-alg.c \
 	stress-aio.c \
@@ -202,6 +266,7 @@
 	stress-cache.c \
 	stress-cacheline.c \
 	stress-cap.c \
+	stress-cgroup.c \
 	stress-chattr.c \
 	stress-chdir.c \
 	stress-chmod.c \
@@ -236,6 +301,7 @@
 	stress-eventfd.c \
 	stress-exec.c \
 	stress-exit-group.c \
+	stress-factor.c \
 	stress-fallocate.c \
 	stress-fanotify.c \
 	stress-far-branch.c \
@@ -292,6 +358,7 @@
 	stress-l1cache.c \
 	stress-landlock.c \
 	stress-lease.c \
+	stress-led.c \
 	stress-link.c \
 	stress-list.c \
 	stress-llc-affinity.c \
@@ -315,6 +382,7 @@
 	stress-memrate.c \
 	stress-memthrash.c \
 	stress-mergesort.c \
+	stress-metamix.c \
 	stress-mincore.c \
 	stress-misaligned.c \
 	stress-mknod.c \
@@ -322,11 +390,13 @@
 	stress-mlockmany.c \
 	stress-mmap.c \
 	stress-mmapaddr.c \
+	stress-mmapfiles.c \
 	stress-mmapfixed.c \
 	stress-mmapfork.c \
 	stress-mmaphuge.c \
 	stress-mmapmany.c \
 	stress-module.c \
+	stress-monte-carlo.c \
 	stress-mprotect.c \
 	stress-mpfr.c \
 	stress-mq.c \
@@ -362,6 +432,7 @@
 	stress-poll.c \
 	stress-prctl.c \
 	stress-prefetch.c \
+	stress-prio-inv.c \
 	stress-priv-instr.c \
 	stress-procfs.c \
 	stress-pthread.c \
@@ -393,6 +464,7 @@
 	stress-rseq.c \
 	stress-rtc.c \
 	stress-sctp.c \
+	stress-schedmix.c \
 	stress-schedpolicy.c \
 	stress-seal.c \
 	stress-seccomp.c \
@@ -407,6 +479,7 @@
 	stress-shm.c \
 	stress-shm-sysv.c \
 	stress-sigabrt.c \
+	stress-sigbus.c \
 	stress-sigchld.c \
 	stress-sigfd.c \
 	stress-sigfpe.c \
@@ -420,6 +493,8 @@
 	stress-sigsegv.c \
 	stress-sigsuspend.c \
 	stress-sigtrap.c \
+	stress-sigxcpu.c \
+	stress-sigxfsz.c \
 	stress-skiplist.c \
 	stress-sleep.c \
 	stress-smi.c \
@@ -449,10 +524,12 @@
 	stress-tee.c \
 	stress-timer.c \
 	stress-timerfd.c \
+	stress-time-warp.c \
 	stress-tlb-shootdown.c \
 	stress-tmpfs.c \
 	stress-touch.c \
 	stress-tree.c \
+	stress-trig.c \
 	stress-tsc.c \
 	stress-tsearch.c \
 	stress-tun.c \
@@ -477,10 +554,13 @@
 	stress-vm-rw.c \
 	stress-vm-segv.c \
 	stress-vm-splice.c \
+	stress-vma.c \
+	stress-vnni.c \
 	stress-wait.c \
 	stress-waitcpu.c \
 	stress-watchdog.c \
 	stress-wcs.c \
+	stress-workload.c \
 	stress-x86cpuid.c \
 	stress-x86syscall.c \
 	stress-xattr.c \
@@ -489,16 +569,26 @@
 	stress-zlib.c \
 	stress-zombie.c \
 
+
+#
+#  Build time core source files
+#
+CORE_SRC_GEN = \
+	core-config.c
+
 #
 # Stress core
 #
 CORE_SRC = \
 	core-affinity.c \
+	core-asm-ret.c \
 	core-cpu.c \
 	core-cpu-cache.c \
+	core-cpuidle.c \
+	core-clocksource.c \
+	core-config-check.c \
 	core-hash.c \
 	core-helper.c \
-	core-icache.c \
 	core-ignite-cpu.c \
 	core-interrupts.c \
 	core-io-uring.c \
@@ -511,72 +601,3 @@
 	core-log.c \
 	core-madvise.c \
 	core-mincore.c \
-	core-mlock.c \
-	core-mmap.c \
-	core-module.c \
-	core-mounts.c \
-	core-mwc.c \
-	core-net.c \
-	core-numa.c \
-	core-out-of-memory.c \
-	core-parse-opts.c \
-	core-perf.c \
-	core-processes.c \
-	core-resources.c \
-	core-sched.c \
-	core-setting.c \
-	core-shared-heap.c \
-	core-shim.c \
-	core-smart.c \
-	core-sort.c \
-	core-thermal-zone.c \
-	core-time.c \
-	core-thrash.c \
-	core-ftrace.c \
-	core-try-open.c \
-	core-vmstat.c \
-	stress-ng.c
-
-SRC = $(CORE_SRC) $(STRESS_SRC)
-OBJS = apparmor-data.o
-OBJS += stress-eigen-ops.o
-OBJS += $(SRC:.c=.o)
-
-APPARMOR_PARSER=/sbin/apparmor_parser
-
-all: config.h stress-ng
-
-.SUFFIXES: .cpp .c .o
-
-.o: Makefile
-
-%.o: %.c $(HEADERS) $(HEADERS_GEN)
-	$(PRE_Q)echo "CC $<"
-	$(PRE_V)$(CC) $(CFLAGS) -c -o $@ $<
-
-#
-#  Use CC for linking if eigen is not being used, otherwise use CXX
-#
-stress-ng: config.h $(OBJS)
-	$(PRE_Q)echo "LD $@"
-	$(eval LINK_TOOL := $(shell if [ -n "$(shell grep '^#define HAVE_EIGEN' config.h)" ]; then echo $(CXX); else echo $(CC); fi))
-	$(eval LDFLAGS_EXTRA := $(shell cat config | grep CONFIG_LDFLAGS | sed 's/CONFIG_LDFLAGS += //' | tr '\n' ' '))
-	$(PRE_V)$(LINK_TOOL) $(OBJS) -lm $(LDFLAGS) $(LDFLAGS_EXTRA) -o $@
-
-stress-eigen-ops.o: config.h
-	@if grep -q '^#define HAVE_EIGEN' config.h; then \
-		echo "CXX stress-eigen-ops.cpp";	\
-		$(CXX) -c -o stress-eigen-ops.o stress-eigen-ops.cpp; \
-	else \
-		echo "CC stress-eigen-ops.c";	\
-		$(CC) -c -o stress-eigen-ops.o stress-eigen-ops.c; \
-	fi
-
-config.h config:
-	$(PRE_Q)echo "Generating config.."
-	$(MAKE) CC="$(CC)" STATIC=$(STATIC) -f Makefile.config
-
-makeconfig: config.h
-
-#
-#  generate apparmor data using minimal core utils tools from apparmor
